﻿using System;
using Ozeki.Media;
using Ozeki.VoIP;

namespace IVR.IVR.Menu
{
    class TransferMenuElement : MenuElement
    {
        private string phoneNumber;

        public TransferMenuElement(string greetingMessage, char returnDtmfCommand):
            base(greetingMessage, returnDtmfCommand)
        {
            
        }

        public TransferMenuElement(WaveStreamPlayback wavPlayback, char returnDtmfCommand) :
            base(wavPlayback, returnDtmfCommand)
        {

        }

        public override void AddSubmenu(MenuElement menuElement, char dtmfCommand)
        {
            throw new NotSupportedException("Cannot add submenu to transfer menu");
        }

        protected override void DtmfReceived(object sender, VoIPEventArgs<DtmfInfo> e)
        {
            char dtmfChar = DtmfNumToChar(e.Item.Signal.Signal);
            if (dtmfChar == returnDtmfCommand)
            {
                phoneNumber = string.Empty;
                OnCompleted();
                return;
            }

            if (dtmfChar == '#')
            {
                if (textToSpeech.IsStreaming)
                {
                    textToSpeech.Stop();
                }
                call.BlindTransfer(phoneNumber);
                return;
            }

            phoneNumber += dtmfChar;
        }
    }
}
